namespace StudySystemClient {
	public interface IRefreshable {
		public abstract async void refresh();
	}

	private class Refresher : Periodic {
		private weak IRefreshable target;

		public Refresher(IRefreshable target, uint period_ms) {
			base(period_ms);
			this.target = target;
		}

		protected override void task() {
			if (target != null) {
				Idle.add(() => {
						target.refresh.begin();
						return false;
					});
			}
		}
	}
}
